#include <stdio.h>
#include <signal.h>
#include <unistd.h>

/* Here, the main program forks three children, Good (pg), Bad (pb),
   and Ugly (pu). By default, all four processes would be in the same
   process group, but here the parent places Bad and Ugly into their own
   group, identified with pb. 

   The kill() system call below is sent to the group pb, hence kills Bad
   and Ugly. If instead, one presses Ctrl-C, then Good and the parent are
   killed (while Bad and Ugly survive). */

int main()
{
	int pg,pb,pu;
	if (!(pg = fork()))
		{ sleep(1); while(1) { printf("good\n"); sleep(3); } }
	else if (!(pb = fork()))
		{ sleep(2); while(1) { printf("bad\n"); sleep(3); } }
	else if (!(pu = fork()))
		{ sleep(3); while(1) { printf("ugly\n"); sleep(3); } }
	else 
	{
		setpgid(pb,pb);
		setpgid(pu,pb);
		printf("type <enter> to kill the bad and ugly\n");
		getchar();
		kill(-pb,SIGTERM);
		while(1) { sleep(10); }
	}
}
